/***************************************************
 * 
	This application uses the XML-RPC.NET library
	by Charles Cook.  The license for this library
	can be found below.
	
	The library source can be obtained at:
	
				http://www.xml-rpc.net/

 ***************************************************/
/* 
XML-RPC.NET library
Copyright (c) 2001-2003, Charles Cook <ccook@cookcomputing.com>

Permission is hereby granted, free of charge, to any person 
obtaining a copy of this software and associated documentation 
files (the "Software"), to deal in the Software without restriction, 
including without limitation the rights to use, copy, modify, merge, 
publish, distribute, sublicense, and/or sell copies of the Software, 
and to permit persons to whom the Software is furnished to do so, 
subject to the following conditions:

The above copyright notice and this permission notice shall be 
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
DEALINGS IN THE SOFTWARE.
*/

using System;
using CookComputing.XmlRpc;

namespace RSSReader
{

	[XmlRpcUrl("http://www.syndic8.com/xmlrpc.php")]
	class Syndic8 : XmlRpcClientProtocol
	{

		[XmlRpcMethod("syndic8.FindFeeds")]
		public int[] FindFeeds(string Pattern, string Field, int Limit)
		{
			return (int[]) Invoke("FindFeeds", new object[] { Pattern, Field, Limit });
		}

		[XmlRpcMethod("syndic8.FindSites")]
		public int[] FindSites(string url)
		{
			return (int[]) Invoke("FindSites", new object[] { url });
		}

		public IAsyncResult BeginFindSites(string url, AsyncCallback callback, object asyncState)
		{
			return BeginInvoke("FindSites", new object[] { url }, this, callback, asyncState);
		}

		public int[] EndFindSites(IAsyncResult ar)
		{
			return (int[]) EndInvoke(ar);
		}

		[XmlRpcMethod("syndic8.GetFeedInfo")]
		public CookComputing.XmlRpc.XmlRpcStruct[] GetFeedInfo(int[] feedIDs)
		{
			CookComputing.XmlRpc.XmlRpcStruct[] o = (CookComputing.XmlRpc.XmlRpcStruct[]) Invoke("GetFeedInfo", new object[] { feedIDs });
			return o;
		}

		public IAsyncResult BeginGetFeedInfo(int[] feedIDs, AsyncCallback callback, object asyncState)
		{
			return BeginInvoke("GetFeedInfo", new object[] { feedIDs }, this, callback, asyncState);
		}

		public object[] EndGetFeedInfo(IAsyncResult ar)
		{
			return (object[]) EndInvoke(ar);
		}

	}

}
